package cokr.xit.fims.excl.dao;

import java.util.List;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.fims.excl.OpnnSbmsn;
import cokr.xit.fims.crdn.Crdn;
import cokr.xit.fims.excl.LevyExclQuery;
import cokr.xit.foundation.component.AbstractMapper;
import cokr.xit.foundation.data.DataObject;

/** 의견제출 대장 정보 DAO
 *
 * <p>상세 설명: 의견제출 대장 테이블에 접근하여 데이터를 조회하고 저장한다.
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-06-27	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Mapper("opnnSbmsnMapper")
public interface OpnnSbmsnMapper extends AbstractMapper {

	/**지정한 조건에 따라 의견제출 대장 목록을 조회하여 반환한다.
	 * @param req 의견제출 대장 조회 조건
	 * @return 의견제출 대장 목록
	 */
	List<DataObject> selectOpnnSbmsnList(LevyExclQuery req);

	/**지정한 조건에 따라 의견제출 대장 객체들을 조회하여 반환한다.
	 * @param req 의견제출 대장 조회 조건
	 * @return 의견제출 대장 객체 목록
	 */
	List<DataObject> selectOpnnSbmsns(LevyExclQuery req);

	/**지정한 조건에 따라 의견제출 대장 정보를 조회하여 반환한다.
	 * @param req 의견제출 대장 조회 조건
	 * @return 의견제출 대장 객체
	 */
	default DataObject selectOpnnSbmsnInfo(LevyExclQuery req) {
		// 삭제 여부 확인
		if (req.getDelYn() == null) {
			req.setDelYn("N");
		}
		// 기본 정렬
		if (req.getOrderBy() == null) {
			req.setOrderBy("OS.OPNN_ID DESC");
		}

		List<DataObject> opnnSbmsns = selectOpnnSbmsns(req);

		return !opnnSbmsns.isEmpty() ? opnnSbmsns.get(0) : null;
	}

	/**지정한 조건에 따라 의견제출 심의의결서 목록을 조회하여 반환한다.
	 * @param opnnId 의견제출 ID
	 * @return 의견제출 대장 객체
	 */
	List<DataObject> selectOpnnSbmsnDlbrDecsns(LevyExclQuery req);

	/**의견제출 대장 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"opnnSbmsn" - 의견제출 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertOpnnSbmsn(OpnnSbmsn opnnSbmsn);

	/**의견제출 대장 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"opnnSbmsn" - 의견제출 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateOpnnSbmsn(OpnnSbmsn opnnSbmsn);

	/**의견제출 대장 심의 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"opnnSbmsn" - 의견제출 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateOpnnSbmsnAnswer(OpnnSbmsn opnnSbmsn);

	/**지정한 의견제출 대장을 삭제한다.
	 * @param params 파라미터
	 * <ul><li>"opnnSbmsn" - 의견제출 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int deleteOpnnSbmsn(OpnnSbmsn opnnSbmsn);

	/**단속 대장 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"crdn" - 단속 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateCrdnOpnnSbmsnYn(Crdn crdn);

}
